package com.fzm.mall.server.front.goods.service;

import com.fzm.mall.server.front.goods.model.MarketingCoupon;
import com.baomidou.mybatisplus.extension.service.IService;
import com.fzm.mall.server.front.goods.model.vo.PageVoWithOne;
import com.fzm.mall.server.front.goods.model.vo.UserCouponVo;
import com.fzm.mall.server.front.order.model.vo.OrderSkuVo;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 商品优惠券 服务类
 * </p>
 *
 * @author fzm
 * @since 2021-03-09
 */
public interface IMarketingCouponService extends IService<MarketingCoupon> {

    List<MarketingCoupon> getByGoodsId(String goodsId,Integer type);

    BigDecimal getPrice(String couponId,BigDecimal amount , Integer size,Integer type);

    boolean checkEffective(String uid, String couponId,Integer type);

    MarketingCoupon getByCouponId(String couponId,Integer type);

    String getGoodsId(String couponId);

    Map<String, BigDecimal> getCoupon(String uid, List<String> goodsIdCouponVos, List<OrderSkuVo> allSkuVo,Integer type);

    List<UserCouponVo> getByMerchantId(String merchantId, Integer type);

    Integer getCount(String merchantId, Integer type);
}
